/*
 * 5.	Sa se realizeze un program care primeste la intrare (tastatura) un sir de numere intregi (cite un numar pe o
 * linie separata)  si afiseaza la iesire elementele de forma 3k, 3k+1 si 3k+2 (in aceasta ordine), k natural.
 * Se va pastra ordinea relativa intre elemente.  Introducerea unui 0 (care nu se va afisa)  la intrare va termina
 * secventa introdusa.
 */

#include <stdio.h>
#include <stdlib.h>

struct coada
{
    int data;
    struct coada* next;
};

void add_Q(int i, int a);
int del_Q(int i);


struct coada* front[3];
struct coada* rear[3];


int main() {
    int i;
    int in = -1;
    int a;

    for (i=0; i<3; i++)
    {
        front[i]= (struct coada*)malloc(sizeof(struct coada*));
        rear[i]= (struct coada*)malloc(sizeof(struct coada*));

        front[i]->next=rear[i];
        rear[i]->next=NULL;
        front[i]->data=0;
        rear[i]->data=0;
    }

    while (in != 0)
    {
        scanf("%d",&in);
        if (in!=0)
        {
            add_Q(in % 3,in);
        }
    }

    for (i=0; i<3; i++)
    {
        while(front[i]->next != rear[i])
        {
            a=del_Q(i);
            printf("%d\n",a);
        }
    }

    return 0;
}

void add_Q(int i, int a)
{
    struct coada* p;

    rear[i]->data=a;
    p=(struct coada*) malloc(sizeof(struct coada));
    p->next=NULL;
    rear[i]->next=p;
    rear[i]=p;
    rear[i]->data=0;
}

int del_Q(int i)
{
    int x;
    struct coada* p;

    if (front[i]->next != rear[i] )
    {
        p=front[i]->next;
        x=p->data;
        front[i]->next=p->next;
        free(p);
        return x;
    }
    return 0;
}