/*
 7.	Sa se realizeze un program care primeste un sir de numere naturale nenule, care pot fi si identice,  de la
 tastatura (pe linii separate) va afisa la iesire secvente de numere sortate  care contin numarul current introdus
 si toate numerele anterior introduse. Introducerea unui 0 (care nu se va afisa)  la intrare va termina secventa
 introdusa. La iesire se va afisa virgula dupa fiecare numar din secventele sortate.
 */

#include <stdio.h>
#include <stdlib.h>


struct bnode {
    int data;
    int cnt;
    struct bnode* left;
    struct bnode* right;
};

struct bnode* new_node_abc(int a);
struct bnode* build_abc(struct bnode*r, int a);
void ldr(struct bnode* r);

struct coada
{
    int data;
    struct coada* next;
};

void add_Q(int a);
int del_Q(void);

struct coada* front;
struct coada* rear;

int main() {

    int in=-1;
    struct bnode* root=NULL;

    front= (struct coada*)malloc(sizeof(struct coada*));
    rear= (struct coada*)malloc(sizeof(struct coada*));

    front->next=rear;
    rear->next=NULL;
    front->data=0;
    rear->data=0;

    int a;

    while(in!=0)
    {
        scanf("%d", &in);
        if (in==0) break;
        add_Q(in);
    }
    while(front->next != rear)
    {
        a=del_Q();
        root=build_abc(root,a);
        ldr(root);
        printf("\n");
    }

    return 0;
}

struct bnode* new_node_abc(int a)
{
    struct bnode* r;

    r= (struct bnode*) malloc(sizeof(struct bnode));
    r->data=a;
    r->cnt=1;
    r->left=NULL;
    r->right=NULL;

    return r;
}

struct bnode* build_abc(struct bnode*r, int a)
{
    if (r==NULL) r = new_node_abc(a);
    else
    {
        if (a < r->data ) r->left=build_abc(r->left,a);
        if (a > r->data ) r->right=build_abc(r->right,a);
        if (a==r->data) r->cnt=r->cnt+1;
    }

    return r;
}

void ldr(struct bnode* r)
{
    int i;
    if(r!=NULL)
    {
        ldr(r->left);
        for (i=0; i < r->cnt; i++) printf("%d,", r->data);
        ldr(r->right);
    }
}

void add_Q(int a)
{
    struct coada* p;

    rear->data=a;
    p=(struct coada*) malloc(sizeof(struct coada));
    rear->next=p;
    rear=p;
    rear->data=0;
}

int del_Q(void)
{
    int x;
    struct coada* p;

    if (front->next != rear )
    {
        p=front->next;
        x=p->data;
        front->next=p->next;
        free(p);
        return x;
    }
    return 0;
}