/*
  * 1.	Sa se scrie un program care afiseaza tipurile de produse si produsele dintr-un magazin.
 * Tipurile de produse si produsele sint introduse de la tastatura in forma: TipProdus, Produs (pe linii separate).
 * Pot fi introduse tipuri si produse identice, dar se vor afisa o singura data.
 * Afisarea se va face in ordinea introducerii la intrare. Introducerea unui 0  ca TipProdus (care nu se va afisa)
 * la intrare va termina secventa introdusa. Numele de tipuri de produse si de produse nu contin spatii si au maxim
 * 100 de caractere
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct TipProdus
{
    char Tip[100];
    struct TipProdus * linkt;
    struct Produs * linkp;
};

struct Produs
{
    char Nume[100];
    struct Produs * next;
};

struct TipProdus* NewTip(char tipP[]);
struct Produs* NewProd(char P[]);

struct TipProdus* EndTip(char tipP[], int* res);
void insertTipProd(char tipP[],char P[]);

void Afisare(void);

struct TipProdus *headerTip;
int result;

int main()
{
headerTip=NewTip("");
char Tip[100];
char Prod[100];

while (1)
{
    scanf("%s",Tip);
    if (strcmp(Tip, "0")==0) break;
    scanf("%s",Prod);
    insertTipProd(Tip,Prod);
}
    Afisare();

    return 0;
}

struct TipProdus* NewTip(char tipP[])
{
   struct TipProdus * t;

    t =(struct TipProdus *) malloc(sizeof(struct TipProdus));
    strcpy(t->Tip, tipP);
    t->linkp=NULL;
    t->linkt=NULL;

    return t;

}

struct Produs* NewProd(char P[])
{
    struct Produs * t;

    t =(struct Produs *) malloc(sizeof(struct Produs));
    strcpy(t->Nume, P);
    t->next=NULL;

    return t;
}

struct TipProdus* EndTip(char tipP[],int* res)
{
    struct TipProdus *t;
    *res = 0;

    t=headerTip;
    while (t->linkt != NULL)
    {
        t=t->linkt;
        if (strcmp(t->Tip,tipP)==0)
        {
         *res=1;
        break;
        }
    }
    return t;
}

void insertTipProd(char tipP[], char P[])
{
    struct TipProdus *t;
    struct TipProdus *p;
    struct Produs *r;
    struct Produs *h;
    int exista =0;

    t = EndTip(tipP, &result);
    h = NewProd(P);

    if (result == 0)
    {
        p = NewTip(tipP);
        t->linkt = p;
    }
    else p=t;

    r=p->linkp;
    if (r == NULL) p->linkp = h;
    else {
        while (r->next!= NULL)
        {
            if (strcmp(r->Nume,P)==0) {exista=1; break;}
                r = r->next;
        }

        if (exista==0)
        {
            if (strcmp(r->Nume,P)!=0) r->next = h;
        }
    }
}

void Afisare(void)
{
   struct TipProdus* t;
   struct Produs* p;

   t=headerTip->linkt;

   while (t != NULL)
   {
       printf("%s\n",t->Tip);
       p=t->linkp;
       while (p!=NULL)
       {
           printf("%s\n",p->Nume);
           p=p->next;
       }
       t=t->linkt;
   }
}