/*
 * 10.	Sa se scrie un program care preia de la tastaura, pe linii separate, perechi de numere naturale (index) si
 * siruri numerice (nume). Programul va afisa la iesire, pe cite o linie, sirurile de caractere in ordinea indexului
 * asociat. Nu se pot da la intrare perechi identice si fiecare sir are un index unic. Introducerea unui 0
 * (care nu se va afisa)  la intrare va termina secventa introdusa. Sirurile de numere au maxim 10 caractere.
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>


struct bnode {
    char nume[10];
    int index;
    struct bnode* left;
    struct bnode* right;
};


struct bnode* build_abc(struct bnode*r, int n, char a[10]);
void ldr_nume(struct bnode* r);



int main() {

    int index = -1;
    char nume[10];

    struct bnode* root=NULL;

    while(index != 0)
    {
        scanf("%d",&index);
        if (index == 0) break;
        scanf("%s",nume);
        root=build_abc(root,index,nume);
    }

    ldr_nume(root);


    return 0;
}

struct bnode* build_abc(struct bnode*r, int n, char a[10])
{
    if (r==NULL)
    {
        r= (struct bnode*) malloc(sizeof(struct bnode));
        strcpy(r->nume,a);
        r->index=n;
        r->left=NULL;
        r->right=NULL;
    }
    else
    {
        if (n < r->index) r->left=build_abc(r->left,n,a);
        if (n > r->index) r->right=build_abc(r->right,n,a);
    }

    return r;
}


void ldr_nume(struct bnode* r)
{
    if(r!=NULL)
    {
        ldr_nume(r->left);
        printf("%s\n",r->nume);
        ldr_nume(r->right);
    }
}




