/*
 * 6.	Se cere sa se realizeze un program ce realizeaza decodificarea unui text care continue doar  vocalele alfabetului.
 *  Sirul de biti asociat unui simbol are lungime variabila astfel:
    A: 0, E: 11, I: 101, O: 1000 si U: 10010.
    Sirul de biti este introdus de la tastatura (un bit pe o line separata) si textul decodificat va fi scris pe ecran
    cite un caracter pe o linie separata). Introducerea unui 2 (care nu se va afisa) la intrare va termina secventa
    introdusa.
 */

#include <stdio.h>
#include <stdlib.h>



char static_tree[64];
struct coada
{
    int data;
    struct coada* next;
};

void add_Q(int a);
int del_Q(void);

struct coada* front;
struct coada* rear;

int main() {

  int i;
  int c=-1;
  int a;

  for (i=1; i<64; i++) static_tree[i]=' ';

    static_tree[2]='A';
    static_tree[7]='E';
    static_tree[13]='I';
    static_tree[24]='O';
    static_tree[50]='U';

    front= (struct coada*)malloc(sizeof(struct coada*));
    rear= (struct coada*)malloc(sizeof(struct coada*));

    front->next=rear;
    rear->next=NULL;
    front->data=2;
    rear->data=2;

    while(c!=2)
    {
        scanf("%d",&c);
        if (c!=2) add_Q(c);
    }
    while(front->next != rear)
    {
        i=1;
        while( (static_tree[2*i] != ' ') || (static_tree[2*i+1] != ' ') )
        {
            a=del_Q();
            if (a<0) break;
            if (a==0) i=2*i;
            else i=2*i+1;
            if(i>=32 && i<=63) break;
        }
        printf("%c\n",static_tree[i]);
    }
    return 0;
}

void add_Q(int a)
{
    struct coada* p;

    rear->data=a;
    p=(struct coada*) malloc(sizeof(struct coada));
    rear->next=p;
    rear=p;
    rear->data=0;
}

int del_Q(void)
{
    int x;
    struct coada* p;

    if (front->next != rear )
    {
        p=front->next;
        x=p->data;
        front->next=p->next;
        free(p);
        return x;
    }
    return -1;
}