/*
 * 8.	Sa se realizeze un program care afiseaza, in ordine descrescatoare elementele unei multimi de numere naturale
 * nenule introduse de la tastatura. Elementele identice se vor afisa o singura data. Introducerea unui 0 (care nu se
 * va afisa) la intrare va termina secventa introdusa.
 */

#include <stdio.h>
#include <stdlib.h>



struct bnode {
    int data;
    struct bnode* left;
    struct bnode* right;
};

struct coada
{
    int data;
    struct coada* next;
};

void add_Q(int a);
int del_Q(void);

struct bnode* build_abc(struct bnode*r, int a);
void rdl(struct bnode* r);

struct coada* front;
struct coada* rear;

int main() {

    int c=-1;

    struct bnode* root=NULL;

    front= (struct coada*)malloc(sizeof(struct coada*));
    rear= (struct coada*)malloc(sizeof(struct coada*));

    front->next=rear;
    rear->next=NULL;
    front->data=0;
    rear->data=0;

    while(c!=0)
    {
        scanf("%d",&c);
        if (c==0) break;
        add_Q(c);
    }

    while(front->next != rear)
    {
        c=del_Q();
        root=build_abc(root,c);
    }

    rdl(root);

    return 0;
}

struct bnode* build_abc(struct bnode*r, int a)
{
    if (r==NULL)
    {
        r= (struct bnode*) malloc(sizeof(struct bnode));
        r->data=a;
        r->left=NULL;
        r->right=NULL;
    }
    else
    {
        if (a < r->data ) r->left=build_abc(r->left,a);
        if (a > r->data ) r->right=build_abc(r->right,a);
    }

    return r;
}

void add_Q(int a)
{
    struct coada* p;

    rear->data=a;
    p=(struct coada*) malloc(sizeof(struct coada));
    rear->next=p;
    rear=p;
    rear->data=0;
}

int del_Q(void)
{
    int x;
    struct coada* p;

    if (front->next != rear )
    {
        p=front->next;
        x=p->data;
        front->next=p->next;
        free(p);
        return x;
    }
    return 0;
}

void rdl(struct bnode* r)
{
    if(r!=NULL)
    {
        rdl(r->right);
        printf("%d\n", r->data);
        rdl(r->left);
    }
}