/*
 * 9.	Sa se realizeze un program care preia de la intrare siruri de caractere  si scrie la iesire un sir de numere
 * naturale nenule care reprezinta ordinea alfabetica a sirurilor de la intrare. Fiecare sir va fi introdus pe o linie
 * separata. Nu se vor da la intrare siruri identice. Introducerea sirului “stop” (care nu se va afisa)  la intrare va
 * termina secventa introdusa. Sirurile de caractere nu contin spatii si au maxim 10 de elemente.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


struct bnode {
    char nume[10];
    int index;
    struct bnode* left;
    struct bnode* right;
};

struct lista
{
    char data[10];
    struct lista* next;
};

struct lista* add_lista(struct lista* h, char a[10]);
void read_lista(char x[10]);

struct bnode* build_abc(struct bnode*r, char a[10]);
void ldr(struct bnode* r);
struct bnode* cauta_abc(struct bnode*r, char a[10]);

struct lista* prim;
struct lista* current;

int nr=0;

int main() {

    char c[10]="";

    struct bnode* root=NULL;
    struct bnode* r=NULL;

    prim= (struct lista*)malloc(sizeof(struct lista*));
    prim->next=NULL;
    strcpy(prim->data,"");
    current=prim;

      while(strcmp(c,"stop") != 0)
    {
        scanf("%s",c);
        if (strcmp(c,"stop") == 0) break;
        current = add_lista(current, c);
    }

    current=prim->next;
    while(current != NULL)
    {
        if (current == NULL) break;
        read_lista(c);
        root=build_abc(root,c);
    }

    ldr(root);

    current=prim->next;

    while(current != NULL)
    {
        if (current == NULL) break;
        read_lista(c);
        r=cauta_abc(root,c);
        if (r!=NULL) printf("%d\n",r->index);
    }

    return 0;
}

struct bnode* build_abc(struct bnode*r, char a[10])
{
    if (r==NULL)
    {
        r= (struct bnode*) malloc(sizeof(struct bnode));
        strcpy(r->nume,a);
        r->index=0;
        r->left=NULL;
        r->right=NULL;
    }
    else
    {
        if ( strcmp(a, r->nume) < 0 ) r->left=build_abc(r->left,a);
        if ( strcmp(a, r->nume) > 0 ) r->right=build_abc(r->right,a);
    }

    return r;
}

struct bnode* cauta_abc(struct bnode*r, char a[10])
{
    if (r==NULL) return NULL;
    if (strcmp(r->nume,a) == 0) return r;
    if (strcmp(a,r->nume) < 0) return cauta_abc(r->left,a);
    if (strcmp(a,r->nume) > 0) return cauta_abc(r->right,a);
}

void ldr(struct bnode* r)
{
    if(r!=NULL)
    {
        ldr(r->left);
        nr++;
        r->index=nr;
        ldr(r->right);
    }
}

struct lista* add_lista(struct lista *h, char a[10])
{
    struct lista* p;

    p=(struct lista*) malloc(sizeof(struct lista));
    p->next=NULL;
    strcpy(p->data,a);
    h->next=p;
    return p;

}

void read_lista(char x[10])
{
    strcpy(x, current->data);
    current=current->next;
}



